﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WinGridMergeCells2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable table0 = new DataTable("Treatment Fluu");
            table0.Columns.Add("col1", typeof(string));
            table0.Columns.Add("col2", typeof(string));
            table0.Columns.Add("id", typeof(int));

            table0.Rows.Add("A", "AAA", 1);
            table0.Rows.Add("B", "BBB", 2);
            table0.Rows.Add("B", "BBB", 3);
            table0.Rows.Add("B", "AAA", 4);
            table0.Rows.Add("c", "AAA", 5);
            table0.Rows.Add("c", "AAA", 6);
            table0.Rows.Add("B", "BBB", 7);
            table0.Rows.Add("A", "AAA", 8);
            table0.Rows.Add("B", "BBB", 9);

            ultraGrid1.DataSource = table0;
            
           
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            foreach (UltraGridColumn col in e.Layout.Bands[0].Columns)
            {
                col.MergedCellEvaluator = new MyMergedCellEvaluator();
                col.MergedCellStyle = MergedCellStyle.Always;
                col.MergedCellEvaluationType = MergedCellEvaluationType.MergeSameText;
            }
        }
    }


    public class MyMergedCellEvaluator : IMergedCellEvaluator
    {
        #region IMergedCellEvaluator Members

        public bool ShouldCellsBeMerged(UltraGridRow row1, UltraGridRow row2, UltraGridColumn column)
        {
            bool result = false;
            switch (column.Index)
            {
                case 0:
                    result = (row1.Cells[column.Key].Value.ToString() == row2.Cells[column.Key].Value.ToString());
                    break;
                default:
                    if(row1.Cells[column.Index -1].IsMergedWith(row2.Cells[column.Index -1]))
                        result = (row1.Cells[column.Key].Value.ToString() == row2.Cells[column.Key].Value.ToString());
                    else
                        result = false;
                    break;
            }
            return result;
        }

        #endregion
    }

}
